# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import cmdlib
import os
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')

# '''''''''''''''''''' # Addon/Mod Info # '''''''''''''''''' #
addon = es.AddonInfo()
addon.name     = 'Round Switcher'
addon.basename = 'roundswitcher'
addon.status   = 0
addon.version  = '1.0.pub'
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# * VARIABLES

temp = {'trigger':15,'current':0}

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Addon State ###
	es.set('sam_' + addon.basename, 1)

	### CMD ###
	cmdlib.registerServerCommand('sam_roundswitcher_trigger', triggerCMD, 'SAM')

	### Create CFG ###
	createCFG()

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Addon State ###
	es.set('sam_' + addon.basename, 1)

	### Unreg ###
	cmdlib.unregisterServerCommand('sam_roundswitcher_trigger')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def triggerCMD(args):
	if args:
		args = ' '.join(args)
		if args.isdigit(): temp['trigger'] = int(args)

# ============================================================================================================================================================= #
# ========================================================================= EVENTS ============================================================================ #
# ============================================================================================================================================================= #
def player_jump(ev):
	if temp['current'] >= temp['trigger']:
		players = es.import_addon('sam/base/pcontrol/moveplayers')
		players.switchTeams()
		temp['current'] = 0
	else:
		temp['current'] += 1
		func.hudhint2('#all', func.lang_addon(addon.basename, 'warning', {'rounds':temp['trigger'] - temp['current']}))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def es_map_start(ev): temp['current'] = 0

# ============================================================================================================================================================= #
# ========================================================================= BLOCKS ============================================================================ #
# ============================================================================================================================================================= #
def createCFG():
	if os.path.isfile(func.dir_addonscfg + addon.basename + '.cfg') == False:
		f = open(func.dir_addonscfg + addon.basename + '.cfg','w')
		f.write('// - - - - - - - - - - - - - - - - - - - - - - - - - - - - #\n')
		f.write('//  Source Admin Menu # Round Switcher configuration file #\n')
		f.write('// - - - - - - - - - - - - - - - - - - - - - - - - - - - - #\n')
		f.write(' \n')
		f.write('// The number of rounds needed to switch teams.\n')
		f.write('//\n')
		f.write('// Default: 15 rounds.\n')
		f.write('   sam_roundswitcher_trigger "15"\n')

# ============================================================================================================================================================= #
