# MAIN IMPORTS ================================================================================================================================================= #
import psyco
psyco.full()
import es
import playerlib
import cmdlib
# ============================================================================================================================================================== #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/base/manager')
block  = es.import_addon('sam/base/pcontrol')

godmodetag     = '#greenGODMODE'
godmode_hudtag = 'GODMODE'

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### CREATE PLAYERS VAR ###
	for ply in playerlib.getPlayerList('#all'):
		var = es.ServerVar('sam_godmode_%s' % ply.steamid)
		var.set(0)

	cmdlib.registerSayCommand('!godmode', godmodeCMD,'SAM')
	cmdlib.registerSayCommand('!sam_godmode', godmodeCMD,'SAM')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### CREATE PLAYERS VAR ###
	for ply in playerlib.getPlayerList('#all'):
		if int(es.ServerVar('sam_godmode_%s' % ply.steamid)) == 1: unsetgodmode(ply)

	cmdlib.unregisterSayCommand('!godmode')
	cmdlib.unregisterSayCommand('!sam_godmode')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def godmodeCMD(userid, args):
	if admins.isAdmin(es.getplayersteamid(userid)):
		if admins.checkAccess(es.getplayersteamid(userid), 'Godmode'):
			if args:
				try:
					target = playerlib.getPlayer(es.getuserid(args[0]))
					if admins.checkImmunity(es.getplayersteamid(userid), target.steamid): moduleAction(userid, target, 1)
				except: func.hudhint(userid, func.lang_pcontrol('target_not_exist', {'target':args[0]}), godmode_hudtag)
			else: block.function(userid, 'Godmode', None)

# ============================================================================================================================================================== #
# ======================================================================= MAIN BLOCKS ========================================================================== #
# ============================================================================================================================================================== #
def moduleAction(userid, target, cmd=0):
	targetvar = es.ServerVar('sam_godmode_%s' % target.steamid)
	if int(targetvar) == 0:
		setgodmode(target)
		func.tell('#all', func.lang_pcontrol('godmode_target_isgod', {'target':target.name}), godmodetag)
	else:
		unsetgodmode(target)
		func.tell('#all', func.lang_pcontrol('godmode_target_isnotgod', {'target':target.name}), godmodetag)
	if cmd == 0: block.function(userid, 'Godmode', None)

# ============================================================================================================================================================== #
# ======================================================================== FUNCTIONS =========================================================================== #
# ============================================================================================================================================================== #
def setgodmode(target):
	targetvar = es.ServerVar('sam_godmode_%s' % target.steamid)
	targetvar.set(1)
	target.godmode(1)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def unsetgodmode(target):
	targetvar = es.ServerVar('sam_godmode_%s' % target.steamid)
	targetvar.set(0)
	target.godmode(0)

# ============================================================================================================================================================== #
# ========================================================================= EVENTS ============================================================================= #
# ============================================================================================================================================================== #
def player_activate(ev):
	var = es.ServerVar('sam_godmode_%s' % ev['userid'])
	var.set(0)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def round_end(ev):
	for ply in playerlib.getPlayerList('#all'):
		var = es.ServerVar('sam_godmode_%s' % ply.steamid)
		var.set(0)

# ============================================================================================================================================================== #