# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import os
import playerlib
import popuplib
import time
import gamethread
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/base/manager')
block  = es.import_addon('sam/base/pcontrol')

# * VARIABLES

mutetag = '#greenMUTE#DimGrey.#greenGAG'

# Keygroups
db     = 'sam_mutelist'
db_dir = 'cstrike/cfg/sam/databases/es_%s_db.txt' % db

# Mute Lengths
lengths = {
		  'b5 Minutes':10,
		  'c30 Minutes':1800,
		  'd1 Hour':3600,
		  'e3 Hours':10800,
		  'f1 Day':86400,
		  'g3 Days':259200,
		  'h1 Week':604800,
		  'aperm':'perm'
		  }

muted = []

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Load Keygroups ###
	if os.path.isfile(db_dir) == True: es.keygroupload(db, func.dbfiles)

	### Gag Filter ###
	es.addons.registerSayFilter(gagFilter)

	### Start Loop ###
	es.addons.registerTickListener(loop)

	### Get Muted ###
	for ply in playerlib.getPlayerList('#human'):
		if isMuted(ply.steamid): muted.append(ply)

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Unload Keygroups ###
	if es.exists('keygroup', db) == 1: es.keygroupdelete(db)

	### Stop Loop ###
	es.addons.unregisterTickListener(loop)

	### Stop Filter ###
	es.addons.unregisterSayFilter(gagFilter)

	### Popups ###
	func.popupDelete('mute')
	func.popupDelete('plist')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def moduleAction(userid):
	func.popupDelete('plist')
	popup = popuplib.easymenu('plist', None, plistChoice)
	popup.c_beginsep = func.pline
	popup.c_pagesep  = func.pline
	popup.settitle('%s | SAM %s\n \n :: %s ' % (func.menutitle, es.ServerVar(func.version), func.lang_titles('choose_player')))
	for ply in playerlib.getPlayerList('#human'):
		if isMuted(ply.steamid) == True: popup.addoption(ply, '%s [Muted]' % (ply.name))
		else: popup.addoption(ply, ply.name)
	popup.submenu(10, 'pcontrol')
	popup.send(userid)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def plistChoice(userid, choice, popup):
	if admins.checkImmunity(es.getplayersteamid(userid), choice):
		if isMuted(choice.steamid) == False:
			templist = [x for x in lengths]
			templist.sort()
			func.popupDelete('mute')
			popup = popuplib.easymenu('mute', None, muteChoice)
			popup.c_beginsep = func.pline
			popup.c_pagesep  = func.pline
			popup.settitle('%s | SAM %s\n \n :: %s ' % (func.menutitle, es.ServerVar(func.version), func.lang_titles('pcontrol_getTime_desc',{'func':'Mute'})))
			for item in templist: popup.addoption({'target':choice, 'time':lengths[item]}, func.lang_pcontrol(item.replace(item[0], '')))
			popup.submenu(10, 'plist')
			popup.send(userid)
		else:
			es.keydelete(db, choice.steamid)
			es.keygroupsave(db, func.dbfiles)
			if choice in muted: muted.remove(choice)
			func.tell('#human', func.lang_pcontrol('mute_unmuted_target',{'target':choice.name}), mutetag)
			block.function(userid, 'Mute', None)
	else: block.modulePopup(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def muteChoice(userid, choice, popup):
	target = choice['target']
	if es.exists('keygroup', db) == 0: es.keygroupcreate(db)
	if es.exists('key', db, target.steamid) == 0: es.keycreate(db, target.steamid)
	if choice['time'] == 'perm': status = 'perm'
	else: status = int(time.time()) + choice['time']
	es.keysetvalue(db, target.steamid, 'name', target.name)
	es.keysetvalue(db, target.steamid, 'stamp', status)
	es.keygroupsave(db, func.dbfiles)
	muted.append(target)
	func.tell('#human', func.lang_pcontrol('mute_muted_target',{'target':target.name}), mutetag)
	block.function(userid, 'Mute', None)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def isMuted(target):
	if es.exists('key', db, target):
		if es.keygetvalue(db, target, 'stamp') == 'perm': return True
		elif int(es.keygetvalue(db, target, 'stamp')) > int(time.time()): return True
		else:
			es.keydelete(db, target)
			es.keygroupsave(db, func.dbfiles)
			if es.getuserid(target) in muted: muted.remove(es.getuserid(target))
			return False
	else: return False

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def loop():
	for ply in playerlib.getPlayerList('#human'):
		for target in muted:
			if isMuted(es.getplayersteamid(target)): es.voicechat('nolisten', ply, target)
	return

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def gagFilter(userid, text, teamonly):
	if isMuted(es.getplayersteamid(userid)):
		func.tell(userid, func.lang_pcontrol('mute_gaged'), mutetag)
		return (0, 0, 0)
	else: return (userid, text, teamonly)

# ============================================================================================================================================================= #
# ========================================================================= EVENTS ============================================================================ #
# ============================================================================================================================================================= #
def player_activate(ev):
	if isMuted(ev['es_steamid']) == True: muted.append(ev['userid'])

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def player_disconnect(ev):
	if ev['userid'] in muted: muted.remove(ev['userid'])

# ============================================================================================================================================================= #